#!/bin/bash
#
# landisk-update.sh
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
ROOTPATH='/mnt/hda5/.update'
UPDATEVER=`cat ${ROOTPATH}/for_HDL-G_series`
DUMMY=1.06
UPFILE="/boot/.update/update.tgz"
TARFILE="${ROOTPATH}/update-files.tar.gz"
UPPERL="${ROOTPATH}/update.pl"

start_led() {
   /usr/local/bin/ledcont stsfastblink 
}

exit_select() {
#    /usr/local/bin/ledcont errfastblink
#    /usr/local/bin/buzcont 10 50 3
    exit $1
}
########################
# start
start_led


# perlでアップデート
${UPPERL} --update
if [ $? != 0 ]; then
    exit_select 3
fi

# サービスの停止の布石
SERVICE=`${UPPERL} --getservice 2>/dev/null | awk -F '=' '{print $1}'`

# remount rw /
mount -o remount,rw,noatime /

# サービスの停止
for i in $SERVICE apache2 HDLFind.sh cron xinetd sysklogd networking
do
    /etc/init.d/$i stop
done

# 必要であれば
#killall buttond
#killall usbhdmng
# Backup setting files
for n in inittab sudoers rc.d/rcS; do
	f=/etc/$n
	if [ -f $f ]; then
		/bin/cp $f $f.backup
		[ $? != 0 ] && error_exit
	fi
done

# Add sudoers
s='/etc/sudoers'
if [ -f $s -a $(/bin/grep -c landisk $s) = 0 ]; then
	echo '' >> $s
	echo 'landisk	ALL=(ALL)	ALL' >> $s
fi

# Add inittab
s='/etc/inittab'
if [ -f $s -a $(/bin/grep -c telnetd $s) = 0 ]; then
	echo '' >> $s
	echo ':2345:respawn:/usr/sbin/telnetd -l /bin/sh -debug 23' >> $s
fi

# tarで展開
tar xvpzf ${TARFILE} -C / || exit_select 1

# ファイルを削除する
rm -f ${UPFILE}
rm -f ${TARFILE}

# 終了処理
${UPPERL} --setversion=$DUMMY
echo "success($DUMMY)" > /mnt/hda5/.update/update.log
